"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEventsFromContract = void 0;
const getEventsFromContract = (contract, eventFilter, creationBlockNumber = 0) => __awaiter(void 0, void 0, void 0, function* () {
    const logs = yield contract.provider.getLogs(Object.assign(Object.assign({}, eventFilter), { fromBlock: creationBlockNumber, toBlock: 'latest' }));
    const parsedLogs = logs.map((log) => {
        const { name } = contract.interface.parseLog(log);
        return Object.assign(Object.assign({}, contract.interface.decodeEventLog(name, log.data, log.topics)), { blockHash: log.blockHash, transactionHash: log.transactionHash });
    });
    return parsedLogs;
});
exports.getEventsFromContract = getEventsFromContract;
//# sourceMappingURL=events.js.map